package com.app.blackjack.players;

import com.app.blackjack.cards.Card;
import lombok.Getter;

import java.util.Arrays;

import static com.app.blackjack.BlackJack.WINNING_WORTH;

public abstract class FairPlayer implements Player {

    private Card[] hand = new Card[0];

    @Getter
    private int winCount = 0;

    @Override
    public final void receiveCard(Card card) {
        hand = Arrays.copyOf(hand, hand.length + 1);
        hand[hand.length - 1] = card;
    }

    @Override
    public final Card[] returnCards() {
        Card[] cards = hand;
        hand = new Card[0];
        return cards;
    }

    @Override
    public final int getCurrentWorth() {
        return Arrays.stream(hand).mapToInt(Card::getWorth).sum();
    }

    @Override
    public final boolean isLosing() {
        return getCurrentWorth() > WINNING_WORTH;
    }

    @Override
    public final void winRound() {
        winCount++;
    }

}
