package com.app.blackjack.players;

import com.app.blackjack.players.strategy.*;
import com.app.users.User;
import lombok.AllArgsConstructor;

import java.util.Random;

@AllArgsConstructor
public class PlayerMapper {

    private final Random random;

    public Player map(User user) {
        // We could use some data from `user`, like favorite strategy, but we are not doing it right now
        return new PlayerWithStrategy(drawStrategy());
    }

    private PlayerStrategy drawStrategy() {
        switch (random.nextInt(5)) {
            case 0:
                return new CarefulStrategy();
            case 1:
                return new CroupierStrategy();
            case 2:
                return new RandomStrategy();
            case 3:
                return new RestrictedStrategy(15);
            case 4:
                return new SleepingStrategy();
        }
        return null;
    }
}
