package com.app.users;

import lombok.AllArgsConstructor;
import org.springframework.lang.Nullable;
import org.springframework.web.bind.annotation.*;

import java.util.Collection;

@RestController
@AllArgsConstructor
public class UserController {

    private final UserService userService;

    @GetMapping("/users")
    public Collection<User> users(@RequestParam(required = false) @Nullable Integer minimumWins) {
        if (minimumWins == null) {
            return userService.getAllUsers();
        } else {
            return userService.getGoodUsers(minimumWins);
        }
    }

    @PostMapping("/users/add")
    public void addUser(@RequestParam String name) {
        userService.addUser(name);
    }

    @DeleteMapping("users/delete")
    public void deleteUser(@RequestParam String name) {
        userService.deleteUser(name);
    }
}
