package com.app.users;

import org.springframework.stereotype.Component;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import static java.util.stream.Collectors.toUnmodifiableList;

@Component
public class UserDatabase {

    /**
     * This is actually a terrible database, as operations are neither thread-safe nor atomic
     */
    private static final Map<String, User> users = new HashMap<>();

    static {
        users.put("Adam", new User("Adam", 4));
        users.put("Rafał", new User("Rafał", 10));
        users.put("Wiktor", new User("Wiktor", 6));
    }

    public User selectUser(String name) {
        return users.get(name);
    }

    public Collection<User> selectUsers() {
        return users.values();
    }

    public Collection<User> selectUsersWhereWinsGreaterOrEqualTo(int wins) {
        return users.values()
                .stream()
                .filter(user -> user.getWins() >= wins)
                .collect(toUnmodifiableList());
    }

    public void insertIntoUsers(User user) {
        users.put(user.getUsername(), user);
    }

    public void deleteUser(String name) {
        users.remove(name);
    }
}
