package com.app.users;

import lombok.AllArgsConstructor;
import org.springframework.stereotype.Service;

import java.util.Collection;

@Service
@AllArgsConstructor
public class UserService {

    private final UserDatabase userDatabase;

    public Collection<User> getAllUsers() {
        return userDatabase.selectUsers();
    }

    public Collection<User> getGoodUsers(int minimumWins) {
        return userDatabase.selectUsersWhereWinsGreaterOrEqualTo(minimumWins);
    }

    public void addUser(String name) {
        userDatabase.insertIntoUsers(new User(name, 0));
    }

    public void deleteUser(String name) {
        userDatabase.deleteUser(name);
    }
}
